#!/system/bin/sh
# portions from franciscofranco, ak, boype & osm0sis + Franco's Dev Team

# custom busybox installation shortcut
bb=/sbin/bb/busybox;

# ensure SuperSU daemonsu/Superuser su_daemon service is running
if [ -e /system/xbin/daemonsu ]; then
  /system/xbin/daemonsu --auto-daemon&
elif [ ! -e /init.superuser.rc ]; then
  /system/xbin/su --daemon&
fi;

# backup and replace Host AP Daemon for working Wi-Fi tether on 3.4 kernel Wi-Fi drivers
$bb [ -e /system/bin/hostapd.dvbak ] || $bb cp /system/bin/hostapd /system/bin/hostapd.dvbak;
$bb cp -f /sbin/hostapd /system/bin/;
$bb chown root.shell /system/bin/hostapd;
$bb chmod 755 /system/bin/hostapd;

# disable debugging
echo 0 > /sys/module/wakelock/parameters/debug_mask;
echo 0 > /sys/module/userwakelock/parameters/debug_mask;
echo 0 > /sys/module/earlysuspend/parameters/debug_mask;
echo 0 > /sys/module/alarm/parameters/debug_mask;
echo 0 > /sys/module/alarm_dev/parameters/debug_mask;
echo 0 > /sys/module/binder/parameters/debug_mask;

# adjust f2fs partition RAM threshold to favor userdata and tweak garbage collection for smaller media
if [ -e /sys/fs/f2fs/mmcblk0p12 ]; then
  echo 20 > /sys/fs/f2fs/mmcblk0p12/ram_thresh;
fi;
for part in /sys/fs/f2fs/mmcblk0p1*; do
  echo 2048 > $part/max_victim_search;
done;

$bb mount -o ro,remount /system;
